<?php
/**
 * FeedSettings
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\FeedClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Feed
 *
 * Ensi Feed
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\FeedClient\Dto;

use \ArrayAccess;
use \Ensi\FeedClient\ObjectSerializer;

/**
 * FeedSettings Class Doc Comment
 *
 * @category Class
 * @package  Ensi\FeedClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class FeedSettings implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'FeedSettings';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'created_at' => '\DateTime',
        'updated_at' => '\DateTime',
        'name' => 'string',
        'code' => 'string',
        'active' => 'bool',
        'type' => 'int',
        'platform' => 'int',
        'active_product' => 'bool',
        'active_category' => 'bool',
        'shop_name' => 'string',
        'shop_url' => 'string',
        'shop_company' => 'string',
        'update_time' => 'int',
        'delete_time' => 'int',
        'feeds' => '\Ensi\FeedClient\Dto\Feed[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'created_at' => 'date-time',
        'updated_at' => 'date-time',
        'name' => null,
        'code' => null,
        'active' => null,
        'type' => null,
        'platform' => null,
        'active_product' => null,
        'active_category' => null,
        'shop_name' => null,
        'shop_url' => null,
        'shop_company' => null,
        'update_time' => null,
        'delete_time' => null,
        'feeds' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'created_at' => false,
        'updated_at' => false,
        'name' => false,
        'code' => false,
        'active' => false,
        'type' => false,
        'platform' => false,
        'active_product' => false,
        'active_category' => false,
        'shop_name' => false,
        'shop_url' => false,
        'shop_company' => false,
        'update_time' => false,
        'delete_time' => false,
        'feeds' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'created_at' => 'created_at',
        'updated_at' => 'updated_at',
        'name' => 'name',
        'code' => 'code',
        'active' => 'active',
        'type' => 'type',
        'platform' => 'platform',
        'active_product' => 'active_product',
        'active_category' => 'active_category',
        'shop_name' => 'shop_name',
        'shop_url' => 'shop_url',
        'shop_company' => 'shop_company',
        'update_time' => 'update_time',
        'delete_time' => 'delete_time',
        'feeds' => 'feeds'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'created_at' => 'setCreatedAt',
        'updated_at' => 'setUpdatedAt',
        'name' => 'setName',
        'code' => 'setCode',
        'active' => 'setActive',
        'type' => 'setType',
        'platform' => 'setPlatform',
        'active_product' => 'setActiveProduct',
        'active_category' => 'setActiveCategory',
        'shop_name' => 'setShopName',
        'shop_url' => 'setShopUrl',
        'shop_company' => 'setShopCompany',
        'update_time' => 'setUpdateTime',
        'delete_time' => 'setDeleteTime',
        'feeds' => 'setFeeds'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'created_at' => 'getCreatedAt',
        'updated_at' => 'getUpdatedAt',
        'name' => 'getName',
        'code' => 'getCode',
        'active' => 'getActive',
        'type' => 'getType',
        'platform' => 'getPlatform',
        'active_product' => 'getActiveProduct',
        'active_category' => 'getActiveCategory',
        'shop_name' => 'getShopName',
        'shop_url' => 'getShopUrl',
        'shop_company' => 'getShopCompany',
        'update_time' => 'getUpdateTime',
        'delete_time' => 'getDeleteTime',
        'feeds' => 'getFeeds'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('created_at', $data, null);
        $this->setIfExists('updated_at', $data, null);
        $this->setIfExists('name', $data, null);
        $this->setIfExists('code', $data, null);
        $this->setIfExists('active', $data, null);
        $this->setIfExists('type', $data, null);
        $this->setIfExists('platform', $data, null);
        $this->setIfExists('active_product', $data, null);
        $this->setIfExists('active_category', $data, null);
        $this->setIfExists('shop_name', $data, null);
        $this->setIfExists('shop_url', $data, null);
        $this->setIfExists('shop_company', $data, null);
        $this->setIfExists('update_time', $data, null);
        $this->setIfExists('delete_time', $data, null);
        $this->setIfExists('feeds', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['id'] === null) {
            $invalidProperties[] = "'id' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalidProperties[] = "'created_at' can't be null";
        }
        if ($this->container['updated_at'] === null) {
            $invalidProperties[] = "'updated_at' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int $id Идентификатор
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets created_at
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     *
     * @param \DateTime $created_at Дата создания
     *
     * @return $this
     */
    public function setCreatedAt($created_at)
    {


        /*if (is_null($created_at)) {
            throw new \InvalidArgumentException('non-nullable created_at cannot be null');
        }*/
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets updated_at
     *
     * @return \DateTime
     */
    public function getUpdatedAt()
    {
        return $this->container['updated_at'];
    }

    /**
     * Sets updated_at
     *
     * @param \DateTime $updated_at Дата обновления
     *
     * @return $this
     */
    public function setUpdatedAt($updated_at)
    {


        /*if (is_null($updated_at)) {
            throw new \InvalidArgumentException('non-nullable updated_at cannot be null');
        }*/
        $this->container['updated_at'] = $updated_at;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name Название фида
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets code
     *
     * @return string|null
     */
    public function getCode()
    {
        return $this->container['code'];
    }

    /**
     * Sets code
     *
     * @param string|null $code Код
     *
     * @return $this
     */
    public function setCode($code)
    {


        /*if (is_null($code)) {
            throw new \InvalidArgumentException('non-nullable code cannot be null');
        }*/
        $this->container['code'] = $code;

        return $this;
    }

    /**
     * Gets active
     *
     * @return bool|null
     */
    public function getActive()
    {
        return $this->container['active'];
    }

    /**
     * Sets active
     *
     * @param bool|null $active Активность фида
     *
     * @return $this
     */
    public function setActive($active)
    {


        /*if (is_null($active)) {
            throw new \InvalidArgumentException('non-nullable active cannot be null');
        }*/
        $this->container['active'] = $active;

        return $this;
    }

    /**
     * Gets type
     *
     * @return int|null
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param int|null $type Тип фида из FeedTypeEnum
     *
     * @return $this
     */
    public function setType($type)
    {


        /*if (is_null($type)) {
            throw new \InvalidArgumentException('non-nullable type cannot be null');
        }*/
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets platform
     *
     * @return int|null
     */
    public function getPlatform()
    {
        return $this->container['platform'];
    }

    /**
     * Sets platform
     *
     * @param int|null $platform Платформа фида из FeedPlatformEnum
     *
     * @return $this
     */
    public function setPlatform($platform)
    {


        /*if (is_null($platform)) {
            throw new \InvalidArgumentException('non-nullable platform cannot be null');
        }*/
        $this->container['platform'] = $platform;

        return $this;
    }

    /**
     * Gets active_product
     *
     * @return bool|null
     */
    public function getActiveProduct()
    {
        return $this->container['active_product'];
    }

    /**
     * Sets active_product
     *
     * @param bool|null $active_product Добавлять в фид только активные товары
     *
     * @return $this
     */
    public function setActiveProduct($active_product)
    {


        /*if (is_null($active_product)) {
            throw new \InvalidArgumentException('non-nullable active_product cannot be null');
        }*/
        $this->container['active_product'] = $active_product;

        return $this;
    }

    /**
     * Gets active_category
     *
     * @return bool|null
     */
    public function getActiveCategory()
    {
        return $this->container['active_category'];
    }

    /**
     * Sets active_category
     *
     * @param bool|null $active_category Добавлять в фид только активные категории
     *
     * @return $this
     */
    public function setActiveCategory($active_category)
    {


        /*if (is_null($active_category)) {
            throw new \InvalidArgumentException('non-nullable active_category cannot be null');
        }*/
        $this->container['active_category'] = $active_category;

        return $this;
    }

    /**
     * Gets shop_name
     *
     * @return string|null
     */
    public function getShopName()
    {
        return $this->container['shop_name'];
    }

    /**
     * Sets shop_name
     *
     * @param string|null $shop_name Название магазина
     *
     * @return $this
     */
    public function setShopName($shop_name)
    {


        /*if (is_null($shop_name)) {
            throw new \InvalidArgumentException('non-nullable shop_name cannot be null');
        }*/
        $this->container['shop_name'] = $shop_name;

        return $this;
    }

    /**
     * Gets shop_url
     *
     * @return string|null
     */
    public function getShopUrl()
    {
        return $this->container['shop_url'];
    }

    /**
     * Sets shop_url
     *
     * @param string|null $shop_url Сайт магазина
     *
     * @return $this
     */
    public function setShopUrl($shop_url)
    {


        /*if (is_null($shop_url)) {
            throw new \InvalidArgumentException('non-nullable shop_url cannot be null');
        }*/
        $this->container['shop_url'] = $shop_url;

        return $this;
    }

    /**
     * Gets shop_company
     *
     * @return string|null
     */
    public function getShopCompany()
    {
        return $this->container['shop_company'];
    }

    /**
     * Sets shop_company
     *
     * @param string|null $shop_company Название организации
     *
     * @return $this
     */
    public function setShopCompany($shop_company)
    {


        /*if (is_null($shop_company)) {
            throw new \InvalidArgumentException('non-nullable shop_company cannot be null');
        }*/
        $this->container['shop_company'] = $shop_company;

        return $this;
    }

    /**
     * Gets update_time
     *
     * @return int|null
     */
    public function getUpdateTime()
    {
        return $this->container['update_time'];
    }

    /**
     * Sets update_time
     *
     * @param int|null $update_time Частота обновления (в часах)
     *
     * @return $this
     */
    public function setUpdateTime($update_time)
    {


        /*if (is_null($update_time)) {
            throw new \InvalidArgumentException('non-nullable update_time cannot be null');
        }*/
        $this->container['update_time'] = $update_time;

        return $this;
    }

    /**
     * Gets delete_time
     *
     * @return int|null
     */
    public function getDeleteTime()
    {
        return $this->container['delete_time'];
    }

    /**
     * Sets delete_time
     *
     * @param int|null $delete_time Время хранения старых версий фидов (в днях)
     *
     * @return $this
     */
    public function setDeleteTime($delete_time)
    {


        /*if (is_null($delete_time)) {
            throw new \InvalidArgumentException('non-nullable delete_time cannot be null');
        }*/
        $this->container['delete_time'] = $delete_time;

        return $this;
    }

    /**
     * Gets feeds
     *
     * @return \Ensi\FeedClient\Dto\Feed[]|null
     */
    public function getFeeds()
    {
        return $this->container['feeds'];
    }

    /**
     * Sets feeds
     *
     * @param \Ensi\FeedClient\Dto\Feed[]|null $feeds feeds
     *
     * @return $this
     */
    public function setFeeds($feeds)
    {


        /*if (is_null($feeds)) {
            throw new \InvalidArgumentException('non-nullable feeds cannot be null');
        }*/
        $this->container['feeds'] = $feeds;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


